/*
 this software is copyright (c) 2001 Dominik Behr <dominikbehr@yahoo.com>
 this software is distributed under GNU Lesser General Public License
 see LICENSE.txt for details 
*/
#define STRICT
#include <windows.h>
#define GXDLL_EXPORTS
#include "gx.h"
#include "debug.h"

/*
 according to Vrc4171a documentation framebuffer is located at 0x0A000000L
 but when I mapped this area and started writting there my LCD became white
 then black and after reset sound stopped working. then after hard reset
 sound wasnt working too. GULP! removing batteries helped. :)
 so I have set screen using GDI to some pattern and mapped whole memory megabyte 
 by megabyte and scanned for the pattern. and found this address :) 
*/
#define CASIO_FRAMEBUFFER 0x0A200000L

/* 
   VirtualCopy is the magic function which allows booting Linux on Windows CE 
   devices.

   http://msdn.microsoft.com/library/default.asp?url=/library/en-us/wceoem/htm/krnl_f_33.asp

   there is one KB article about it
   http://support.microsoft.com/support/kb/articles/Q213/3/59.ASP

   
   parameters are:
   LPVOID pMemoryBlock
   LPVOID pPhysicalAddress
   DWORD dwBlockSize
   DWORD dwProtectionFlags
   
   it seems there are two ways to map memory
   if physical address is less than 512MB it should be ORed with 0x80000000L
   and ProtectionFlags should be PAGE_READWRITE | PAGE_NOCACHE
   else
   physical address has to be shifted right by 8 abd
   ProtectionFlags should be PAGE_READWRITE | PAGE_NOCACHE | PAGE_PHYSICAL
*/   
extern "C" {
__declspec(dllimport) BOOL VirtualCopy(LPVOID, LPVOID, DWORD, DWORD);
};


/***********************************************************************************************

***********************************************************************************************/
BOOL APIENTRY 
DllMain(HANDLE hModule, 
        DWORD  ul_reason_for_call, 
        LPVOID lpReserved)
{
 return TRUE;
}

/***********************************************************************************************

***********************************************************************************************/
static DWORD
GetPageSize(void)
{
 static int init = 0;
 static SYSTEM_INFO stInfo;

 if (!init) 
    {
     GetSystemInfo(&stInfo);
     init = 1;
     }
 return (stInfo.dwPageSize);
}

//typedef LRESULT (CALLBACK *PFNWNDPROC)(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
typedef int (__cdecl *PFNWNDPROC)(void);

static char *g_pMem = 0;
static unsigned int g_uInputOpened = 0;
static unsigned int g_uTaskbarSubclassed = 0;
static unsigned int g_uTaskbarHidden = 0;
static HWND g_hWnd = 0;
static DWORD g_dwFlags;
static PFNWNDPROC pfnOldTaskbarProc = 0;
static TCHAR *pszTaskbarClass = TEXT("HHTaskBar");

/***********************************************************************************************

***********************************************************************************************/
LRESULT CALLBACK 
TaskbarProc(HWND hWnd, 
            UINT uMsg, 
            WPARAM wParam, 
            LPARAM lParam)
{
 static DWORD dwStateC1 = 0,
              dwStateC2 = 0,
              dwStateC3 = 0, 
              dwStateC4 = 0;
 if (uMsg == WM_KEYDOWN 
     || uMsg == WM_KEYUP)
    {
     DWORD dwNewStateC1, dwNewStateC2, dwNewStateC3, dwNewStateC4;
     HWND hForeWnd;

     hForeWnd = g_hWnd;
     if (!hForeWnd)
        hForeWnd = GetForegroundWindow();
     if (uMsg == WM_KEYDOWN 
         &&  LOWORD(wParam) != 0x5B)
        PostMessage(hForeWnd, uMsg, wParam, lParam);
     dwNewStateC1 = GetAsyncKeyState(0xC1);
     dwNewStateC2 = GetAsyncKeyState(0xC2);
     dwNewStateC3 = GetAsyncKeyState(0xC3);
     dwNewStateC4 = GetAsyncKeyState(0xC4);

     if (dwStateC1 && !dwNewStateC1)
        PostMessage(hForeWnd, WM_KEYUP, 0xC1, 0xC0000001);
     if (dwStateC2 && !dwNewStateC2)
        PostMessage(hForeWnd, WM_KEYUP, 0xC2, 0xC0000001);
     if (dwStateC3 && !dwNewStateC3)
        PostMessage(hForeWnd, WM_KEYUP, 0xC3, 0xC0000001);
     if (dwStateC4 && !dwNewStateC4)
        PostMessage(hForeWnd, WM_KEYUP, 0xC4, 0xC0000001);                

     dwStateC1 = dwNewStateC1;
     dwStateC2 = dwNewStateC2;
     dwStateC3 = dwNewStateC3;
     dwStateC4 = dwNewStateC4;
     return 0;         
    }
 return CallWindowProc((WNDPROC)pfnOldTaskbarProc, hWnd, uMsg, wParam, lParam);
}

/***********************************************************************************************

***********************************************************************************************/
static void
TaskbarHide(void)
{
 HWND hWnd;
 if (g_uTaskbarHidden)
    return;
 hWnd = FindWindow(pszTaskbarClass, 0);
 ShowWindow(hWnd, SW_HIDE);
 g_uTaskbarHidden = 1;
}

/***********************************************************************************************

***********************************************************************************************/
static void
TaskbarShow(void)
{
 HWND hWnd;
 if (!g_uTaskbarHidden)
    return;
 hWnd = FindWindow(pszTaskbarClass, 0);
 ShowWindow(hWnd, SW_SHOWNA);
 g_uTaskbarHidden = 0;
}

/***********************************************************************************************

***********************************************************************************************/
static void
TaskbarSubclass(void)
{
 HWND hWnd;
 if (g_uTaskbarSubclassed)
    return;
 hWnd = FindWindow(pszTaskbarClass, 0);
 pfnOldTaskbarProc = (PFNWNDPROC)GetWindowLong(hWnd, GWL_WNDPROC);
 if (!SetWindowLong(hWnd, GWL_WNDPROC, (LONG)TaskbarProc))
    {
     #ifdef DEBUG
     DebugMessage(TEXT("Fuck!\n"));
     #endif
     return;
    }
 g_uTaskbarSubclassed = 1; 
}

/***********************************************************************************************

***********************************************************************************************/
static void
TaskbarRestore(void)
{
 HWND hWnd;
 if (!g_uTaskbarSubclassed)
    return;
 hWnd = FindWindow(pszTaskbarClass, 0);
 SetWindowLong(hWnd, GWL_WNDPROC, (LONG)pfnOldTaskbarProc);
 g_uTaskbarSubclassed = 0;
}

/***********************************************************************************************

***********************************************************************************************/
GXDLL_API int 
GXOpenDisplay(HWND hWnd, DWORD dwFlags)
{
 DWORD dwPageSize;
 DWORD dwSize;

 {
  SYSTEM_INFO stSI;
  OSVERSIONINFO stOI;
  HKEY hKey;
  DWORD dwType; 
  TCHAR aszName[256];
  DWORD dwSize;

  stOI.dwOSVersionInfoSize = sizeof(stOI);

  GetSystemInfo(&stSI);
  GetVersionEx(&stOI);

  if (!(stSI.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_MIPS 
        && stSI.dwProcessorType == PROCESSOR_MIPS_R4000 
        && stOI.dwMajorVersion == 2
        && stOI.dwMinorVersion == 11)
     )
     return 0;

  if (ERROR_SUCCESS != RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Platform"), 0, 0, &hKey))
     return 0;
  dwSize = 256 * sizeof(TCHAR);
  if (ERROR_SUCCESS != RegQueryValueEx(hKey, TEXT("Name"), 0, &dwType, (LPBYTE)aszName, &dwSize))
     {
      RegCloseKey(hKey);
      return 0;
     }
  RegCloseKey(hKey);
  /* oddly enough e-105 and e-100 have the same platform name */
  if (wcscmp(aszName, TEXT("Casio Jx530 CE2.11")) != 0)
     return 0;
 }

 if (!hWnd)
    hWnd = GetActiveWindow();
 g_dwFlags = dwFlags;
 g_hWnd = hWnd;
 g_uInputOpened = 0;
 g_uTaskbarSubclassed = 0;

 dwPageSize = GetPageSize();
 dwSize = 256*320*2;
 dwSize += dwPageSize - 1;
 dwSize &= 0xFFFFFFFF - (dwPageSize - 1);
 g_pMem = (char *)VirtualAlloc(0, dwSize, MEM_RESERVE, PAGE_NOACCESS);
 if (!g_pMem)
    return 0;

 VirtualCopy((LPVOID)g_pMem, 
             (LPVOID)((CASIO_FRAMEBUFFER | 0x80000000L)), 
             dwSize, 
             PAGE_READWRITE | PAGE_NOCACHE);

 if (g_dwFlags & GX_FULLSCREEN)
    TaskbarHide();
     
 return 1;
}

extern "C" int 
compat_GXOpenDisplay(HWND hWnd, DWORD dwFlags);

int 
compat_GXOpenDisplay(HWND hWnd, DWORD dwFlags)
{
 return GXOpenDisplay(hWnd, dwFlags) ;
}

/***********************************************************************************************

***********************************************************************************************/
GXDLL_API int 
GXCloseDisplay()
{
 if (!g_pMem)
    return 0;

 if (g_uTaskbarHidden)
    TaskbarShow();
 if (g_uTaskbarSubclassed)
    TaskbarRestore();

 VirtualFree((LPVOID)g_pMem, 0, MEM_RELEASE);
 g_pMem = 0;
 return 1;
}

/***********************************************************************************************

***********************************************************************************************/
GXDLL_API void *
GXBeginDraw(void)
{
 return (void *)g_pMem;
}

/***********************************************************************************************

***********************************************************************************************/
GXDLL_API int 
GXEndDraw(void)
{
 return 1;
}

/***********************************************************************************************

***********************************************************************************************/
GXDLL_API int 
GXOpenInput(void)
{
 if (g_uInputOpened)
    return 0;
 TaskbarSubclass();
 if (!g_uTaskbarSubclassed)
    return 0;
 g_uInputOpened = 1;
 return 1;
}

/***********************************************************************************************
 Action - VK_F23 0x86
 Wheel Up,  Arrow Up is VK_UP 0x26
 Wheel Down, Arrow Down is VK_DOWN 0x28
 Arrow Left is VK_LEFT 0x25
 Arrow Right is VK_RIGHT 0x27
 Exit is VK_F24 DOWN - 0x87 UP - 0x1B why ???
***********************************************************************************************/
GXDLL_API int 
GXCloseInput(void)
{
 if (!g_uInputOpened)
    return 0;
 TaskbarRestore();
 g_uInputOpened = 0;
 return 1;
}

/***********************************************************************************************

***********************************************************************************************/
GXDLL_API GXDisplayProperties 
GXGetDisplayProperties(void)
{
 struct GXDisplayProperties stProps;
 stProps.cxWidth = 240;
 stProps.cyHeight = 320;
 stProps.cbxPitch = 2;
 stProps.cbyPitch = 2*256;
 stProps.cBPP = 16;
 stProps.ffFormat = kfDirect565;
 return stProps; 
}

/***********************************************************************************************
 this is broken now
 i have to find out what PocketPC Casio devices return in this function

 buttons on casiopeia

 power     ??

 esc 0x87/0x1B

 up 0x26

 action 0xD

 down 0x28

 recorder 0xC1


           up 0x26        
                              rocket 0xC2

    left 0x25   right 0x27            rolodex 0xC4
                           calendar 0xC3
           down 0x28

 strangely enough esc button on press sends 0x87 and on release 0x1B

***********************************************************************************************/
GXDLL_API GXKeyList 
GXGetDefaultKeys(int iOptions)
{
 struct GXKeyList stList;
 stList.vkUp = VK_UP;				
 stList.ptUp.x = 0;				
 stList.ptUp.y = 0;
 stList.vkDown = VK_DOWN;
 stList.ptDown.x = 0;
 stList.ptDown.y = 0;
 stList.vkLeft = VK_LEFT;
 stList.ptLeft.x = 0;
 stList.ptLeft.y = 0;
 stList.vkRight = VK_RIGHT;
 stList.ptRight.x = 0;
 stList.ptRight.y = 0;
 stList.vkA = 0xC2;
 stList.ptA.x = 0;
 stList.ptA.y = 0;
 stList.vkB = 0xC3;
 stList.ptB.x = 0;
 stList.ptB.y = 0;
 stList.vkC = 0xC4;
 stList.ptC.x = 0;
 stList.ptC.y = 0;
 stList.vkStart = 0x87;
 stList.ptStart.x = 0;
 stList.ptStart.y = 0;
 return stList;
}

/***********************************************************************************************
 there is nothing here yet
***********************************************************************************************/
GXDLL_API int 
GXSuspend(void)
{
 if (g_uTaskbarHidden)
    TaskbarShow();
 if (g_uTaskbarSubclassed)
    TaskbarRestore();
 return 1;
}

/***********************************************************************************************
 there is nothing here yet
***********************************************************************************************/
GXDLL_API int 
GXResume(void)
{
 if (g_dwFlags & GX_FULLSCREEN)
    TaskbarHide();
 if (g_uInputOpened)
    TaskbarSubclass();
 return 1;
}

/***********************************************************************************************
 i am not sure what this function is doing but since it is suppsed to work
 when GXIsDisplayDRAMBuffer() returns TRUE i dont care
***********************************************************************************************/
GXDLL_API int 
GXSetViewport(DWORD dwTop, DWORD dwHeight, DWORD dwReserved1, DWORD dwReserved2)
{
 // unsupported
 return 0;
}

/***********************************************************************************************
 it seems some devices do not expose hardware frame buffer and they return TRUE here
***********************************************************************************************/
GXDLL_API BOOL 
GXIsDisplayDRAMBuffer()
{
 return FALSE;
}

